local MM = GetAddOnMetadata("MarkMe", "Title")
local Name, MMNS = ...;

MMNS.defaultBackdrop = {
	bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
	edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
	tile = true,
	tileSize = 16,
	edgeSize = 16,
	insets = {left = 2, right = 2, top = 2, bottom = 2,}
}

MMNS.BlackAlphaBackdrop = {
	bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
}

MMNS.Themes_Struct =
{
["Default"] = {BackdropColor = {0.1,0.1,0.1,0.7}, Backdrop = MMNS.defaultBackdrop},
["Minimal"] = {BackdropColor = {0.1,0.1,0.1,0.7}, Backdrop = nil},
["Black Alpha"] = {BackdropColor = {0.1,0.1,0.1,0.7}, Backdrop = MMNS.BlackAlphaBackdrop},
["Black Solid"] = {BackdropColor = {0.1,0.1,0.1,1}, Backdrop = MMNS.BlackAlphaBackdrop}
}

MMNS.Layout_Struct =
{
["Horizontal"] = {
	Mainframe_Size = {255,40}, 
	Icon_Frame_Rel_Points = {"LEFT", "LEFT"}, 
	Readycheck_Frame_Rel_Points = {"RIGHT", "LEFT"}, 
	Announce_Frame_Rel_Points = {"LEFT", "RIGHT"}, 
	Skull_Rel_Points = {"LEFT", "LEFT", {10,0}},
	Cross_Rel_Points = {"LEFT", "RIGHT", {5,0}},
	Square_Rel_Points = {"LEFT", "RIGHT", {5,0}},
	Moon_Rel_Points = {"LEFT", "RIGHT", {5,0}},
	Triangle_Rel_Points = {"LEFT", "RIGHT", {5,0}},
	Diamond_Rel_Points = {"LEFT", "RIGHT", {5,0}},
	Circle_Rel_Points = {"LEFT", "RIGHT", {5,0}},
	Star_Rel_Points = {"LEFT", "RIGHT", {5,0}}
	},
["Vertical"] = {
	Mainframe_Size = {40,255}, 
	Icon_Frame_Rel_Points = {"TOP", "TOP"}, 
	Readycheck_Frame_Rel_Points = {"BOTTOM", "TOP"}, 
	Announce_Frame_Rel_Points = {"TOP", "BOTTOM"}, 
	Skull_Rel_Points = {"TOP", "TOP", {0,-10}},
	Cross_Rel_Points = {"TOP", "BOTTOM", {0,-5}},
	Square_Rel_Points = {"TOP", "BOTTOM", {0,-5}},
	Moon_Rel_Points = {"TOP", "BOTTOM", {0,-5}},
	Triangle_Rel_Points = {"TOP", "BOTTOM", {0,-5}},
	Diamond_Rel_Points = {"TOP", "BOTTOM", {0,-5}},
	Circle_Rel_Points = {"TOP", "BOTTOM", {0,-5}},
	Star_Rel_Points = {"TOP", "BOTTOM", {0,-5}}
	}
}

local Row_Height = 36
----------- Settings -------------

MarkMeOptions = {};
MarkMeOptions.panel = CreateFrame( "Frame", "MarkMeOptions", InterfaceOptionsFramePanelContainer );
MarkMeOptions.panel.name = MM.." Options";


local MMOptionsText = MarkMeOptions.panel:CreateFontString("MarkMeOptionsText", "OVERLAY", "ChatFontNormal")
MMOptionsText:SetPoint("TOP", MarkMeOptions.panel, "TOP",0,-10)
MMOptionsText:SetText(MM.."|cffe1a500 Options")
MMOptionsText:SetFont("Fonts\\ARIALN.TTF", 16)

local MMOptionsScroll = CreateFrame("ScrollFrame", nil, MarkMeOptions.panel, "UIPanelScrollFrameTemplate");
MMOptionsScroll:SetPoint("TOPLEFT", 3, -50)
MMOptionsScroll:SetPoint("BOTTOMRIGHT", -27, 4)

local MMOptionsSrollBody = CreateFrame("Frame");
MMOptionsScroll:SetScrollChild(MMOptionsSrollBody)
MMOptionsSrollBody:SetWidth(InterfaceOptionsFramePanelContainer:GetWidth()-18)
MMOptionsSrollBody:SetHeight(1)

local General_Settings = CreateFrame("Frame", nil, MMOptionsSrollBody)
General_Settings:SetPoint("TOPLEFT", MMOptionsSrollBody, "TOPLEFT", 0, 0)
General_Settings:SetPoint("TOPRIGHT", MMOptionsSrollBody, "TOPRIGHT", 0, 0)
General_Settings:SetHeight(62)
	local Options_Cat_General = General_Settings:CreateFontString("Options_Cat_General", "OVERLAY", "GameFontNormal")
	Options_Cat_General:SetText("General")
	Options_Cat_General:SetPoint("TOPLEFT", General_Settings, "TOPLEFT")
	Options_Cat_General:SetPoint("TOPRIGHT", General_Settings, "TOPRIGHT")
	local Lock_Row = CreateFrame("Frame", nil, General_Settings)
	Lock_Row:SetPoint("TOPLEFT", Options_Cat_General, "BOTTOMLEFT", 0, 0)
	Lock_Row:SetPoint("TOPRIGHT", Options_Cat_General, "BOTTOMRIGHT", 0, 0)
	Lock_Row:SetHeight(Row_Height)
		local Lock_Toggle_Text = Lock_Row:CreateFontString("Lock_Toggle_Text", "OVERLAY", "ChatFontNormal")
		Lock_Toggle_Text:SetText("Lock frame position")
		Lock_Toggle_Text:SetPoint("LEFT", Lock_Row, "LEFT", 10,0)
		local Lock_Toggle = CreateFrame("CheckButton", "Lock_Toggle", Lock_Row, "UICheckButtonTemplate")
		Lock_Toggle:SetPoint("RIGHT", Lock_Row, "RIGHT", -10,0)
		Lock_Toggle:SetSize(26,26)
		Lock_Toggle:SetScript("OnClick", function(MMNS) MM_Lock_Frame() end)
		
local Visual_Settings = CreateFrame("Frame", nil, MMOptionsSrollBody)
Visual_Settings:SetPoint("TOPLEFT", General_Settings, "BOTTOMLEFT", 0, 0)
Visual_Settings:SetPoint("TOPRIGHT", General_Settings, "BOTTOMRIGHT", 0, 0)
Visual_Settings:SetHeight(216)		
	local Options_Cat_Visual = Visual_Settings:CreateFontString("Options_Cat_Visual", "OVERLAY", "GameFontNormal")
	Options_Cat_Visual:SetText("Visual")
	Options_Cat_Visual:SetPoint("TOPLEFT", Visual_Settings, "TOPLEFT")
	Options_Cat_Visual:SetPoint("TOPRIGHT", Visual_Settings, "TOPRIGHT")
	local Cog_Row = CreateFrame("Frame", nil, General_Settings)
	Cog_Row:SetPoint("TOPLEFT", Options_Cat_Visual, "BOTTOMLEFT", 0, 0)
	Cog_Row:SetPoint("TOPRIGHT", Options_Cat_Visual, "BOTTOMRIGHT", 0, 0)
	Cog_Row:SetHeight(Row_Height)
		local Cog_Toggle_Text = Cog_Row:CreateFontString("Cog_Toggle_Text", "OVERLAY", "ChatFontNormal")
		Cog_Toggle_Text:SetText("Show options cog")
		Cog_Toggle_Text:SetPoint("LEFT", Cog_Row, "LEFT", 10, 0)
		local Cog_Toggle = CreateFrame("CheckButton", "Cog_Toggle", Cog_Row, "UICheckButtonTemplate")
		Cog_Toggle:SetPoint("RIGHT", Cog_Row, "RIGHT", -10,0)
		Cog_Toggle:SetSize(26,26)
		Cog_Toggle:SetScript("OnClick", function(MMNS) MM_Options_Cog_Toogle() end)

	local Theme_Row = CreateFrame("Frame", nil, Visual_Settings)
	Theme_Row:SetPoint("TOPLEFT", Cog_Row, "BOTTOMLEFT", 0, 0)
	Theme_Row:SetPoint("TOPRIGHT", Cog_Row, "BOTTOMRIGHT", 0, 0)
	Theme_Row:SetHeight(Row_Height)
		local Theme_Text = Theme_Row:CreateFontString("Theme_Text", "OVERLAY", "ChatFontNormal")
		Theme_Text:SetText("Use theme")
		Theme_Text:SetPoint("LEFT", Theme_Row, "LEFT", 10, 0)
		local Theme_Dropdown = CreateFrame("Frame", "Theme_Dropdown", Theme_Row, 'UIDropDownMenuTemplate')
		Theme_Dropdown:SetPoint("RIGHT", Theme_Row, "RIGHT", -85,0)
		local Theme_Dropdown_Text = Theme_Dropdown:CreateFontString("Theme_Dropdown_Text", 'OVERLAY', 'GameFontNormal')
		Theme_Dropdown_Text:SetPoint("TOPLEFT", 20, 10)
		
	local Layout_Row = CreateFrame("Frame", nil, Visual_Settings)
	Layout_Row:SetPoint("TOPLEFT", Theme_Row, "BOTTOMLEFT", 0, 0)
	Layout_Row:SetPoint("TOPRIGHT", Theme_Row, "BOTTOMRIGHT", 0, 0)
	Layout_Row:SetHeight(Row_Height)
		local Layout_Text = Layout_Row:CreateFontString("Layout_Text", "OVERLAY", "ChatFontNormal")
		Layout_Text:SetText("Use layout")
		Layout_Text:SetPoint("LEFT", Layout_Row, "LEFT", 10, 0)
		local Layout_Dropdown = CreateFrame("Frame", "Layout_Dropdown", Layout_Row, 'UIDropDownMenuTemplate')
		Layout_Dropdown:SetPoint("RIGHT", Layout_Row, "RIGHT", -85,0)
		local Layout_Dropdown_Text = Layout_Dropdown:CreateFontString("Layout_Dropdown_Text", 'OVERLAY', 'GameFontNormal')
		Layout_Dropdown_Text:SetPoint("TOPLEFT", 20, 10)
	
	local Fade_Row = CreateFrame("Frame", nil, Visual_Settings)
	Fade_Row:SetPoint("TOPLEFT", Layout_Row, "BOTTOMLEFT", 0, 0)
	Fade_Row:SetPoint("TOPRIGHT", Layout_Row, "BOTTOMRIGHT", 0, 0)
	Fade_Row:SetHeight(Row_Height)
		local Fade_Text = Fade_Row:CreateFontString("Fade_Text", "OVERLAY", "ChatFontNormal")
		Fade_Text:SetText("Bar fade:")
		Fade_Text:SetPoint("LEFT", Fade_Row, "LEFT", 10,0)
		local Fade_Slider = CreateFrame("Slider", "Fade_Slider", Fade_Row, "OptionsSliderTemplate")
		Fade_Slider:SetPoint("RIGHT", Fade_Row, "RIGHT", -10, 0)
		Fade_Slider:SetSize(180,14)
		Fade_Slider:SetMinMaxValues(0.1,1)
		Fade_Slider:SetValue(100)
		Fade_Slider:SetValueStep(0.05)
		Fade_Slider:SetOrientation("HORIZONTAL")
		Fade_Slider:SetScript("OnValueChanged", function(self) getglobal(Fade_Slider:GetName().."Text"):SetText(MM .." fade: "..math.floor(Fade_Slider:GetValue()*100).."%") MM_Preview_Fade(MMNS) end)
		Fade_Slider:SetScript("OnMouseUp", function(self) MM_Update_Fade(MMNS) end)
		getglobal(Fade_Slider:GetName() .. 'Low'):SetText('10%');
		getglobal(Fade_Slider:GetName() .. 'High'):SetText('100%');
	
	local Scale_Row = CreateFrame("Frame", nil, Visual_Settings)
	Scale_Row:SetPoint("TOPLEFT", Fade_Row, "BOTTOMLEFT", 0, 0)
	Scale_Row:SetPoint("TOPRIGHT", Fade_Row, "BOTTOMRIGHT", 0, 0)
	Scale_Row:SetHeight(Row_Height)
		local Scale_Text = Scale_Row:CreateFontString("Use_Fade_Text", "OVERLAY", "ChatFontNormal")
		Scale_Text:SetText("Bar scale:")
		Scale_Text:SetPoint("LEFT", Scale_Row, "LEFT", 10, 0)
		local Scale_Slider = CreateFrame("Slider", "Scale_Slider", Scale_Row, "OptionsSliderTemplate")
		Scale_Slider:SetPoint("RIGHT", Scale_Row, "RIGHT", -10, 0)
		Scale_Slider:SetSize(180,14)
		Scale_Slider:SetMinMaxValues(0.5,1.5)
		Scale_Slider:SetValue(1)
		Scale_Slider:SetValueStep(0.5)
		Scale_Slider:SetOrientation("HORIZONTAL")
		Scale_Slider:SetScript("OnValueChanged", function(self) getglobal(Scale_Slider:GetName().."Text"):SetText(MM .." Scale: "..math.floor(Scale_Slider:GetValue()*100).."%") MM_Preview_Scale(MMNS) end)
		Scale_Slider:SetScript("OnMouseUp", function(self) MM_Update_Scale(MMNS) end)
		getglobal(Scale_Slider:GetName() .. 'Low'):SetText('50%');
		getglobal(Scale_Slider:GetName() .. 'High'):SetText('150%');

local Features_Settings = CreateFrame("Frame", nil, MMOptionsSrollBody)
Features_Settings:SetPoint("TOPLEFT", Visual_Settings, "BOTTOMLEFT", 0, 0)
Features_Settings:SetPoint("TOPRIGHT", Visual_Settings, "BOTTOMRIGHT", 0, 0)
Features_Settings:SetHeight(108)
	local Options_Cat_Features = Features_Settings:CreateFontString("Options_Cat_Visual", "OVERLAY", "GameFontNormal")
	Options_Cat_Features:SetText("Features")
	Options_Cat_Features:SetPoint("TOPLEFT", Features_Settings, "TOPLEFT")
	Options_Cat_Features:SetPoint("TOPRIGHT", Features_Settings, "TOPRIGHT")
	
	local Readycheck_Row = CreateFrame("Frame", nil, Features_Settings)
	Readycheck_Row:SetPoint("TOPLEFT", Options_Cat_Features, "BOTTOMLEFT", 0, 0)
	Readycheck_Row:SetPoint("TOPRIGHT", Options_Cat_Features, "BOTTOMRIGHT", 0, 0)
	Readycheck_Row:SetHeight(Row_Height)
		local Readycheck_Toggle_Text = Readycheck_Row:CreateFontString("Readycheck_Toggle_Text", "OVERLAY", "ChatFontNormal")
		Readycheck_Toggle_Text:SetText("Show Readycheck frame")
		Readycheck_Toggle_Text:SetPoint("LEFT", Readycheck_Row, "LEFT", 10, 0)
		local Readycheck_Toggle = CreateFrame("CheckButton", "Readycheck_Toggle", Readycheck_Row, "UICheckButtonTemplate")
		Readycheck_Toggle:SetPoint("RIGHT", Readycheck_Row, "RIGHT", -10, 0)
		Readycheck_Toggle:SetSize(26,26)
		Readycheck_Toggle:SetScript("OnClick", function(self) MM_Show_Readycheck_Toggle(MMNS) end)
		

	local Announcer_Row = CreateFrame("Frame", nil, Features_Settings)
	Announcer_Row:SetPoint("TOPLEFT", Readycheck_Row, "BOTTOMLEFT", 0, 0)
	Announcer_Row:SetPoint("TOPRIGHT", Readycheck_Row, "BOTTOMRIGHT", 0, 0)
	Announcer_Row:SetHeight(Row_Height)
		local Announcer_Text = Announcer_Row:CreateFontString("Announcer_Text", "OVERLAY", "ChatFontNormal")
		Announcer_Text:SetText("Show Announcer frame")
		Announcer_Text:SetPoint("LEFT", Announcer_Row, "LEFT", 10, 0)
		local Show_Announcer_Toggle = CreateFrame("CheckButton", "Show_Announcer_Toggle", Announcer_Row, "UICheckButtonTemplate")
		Show_Announcer_Toggle:SetPoint("RIGHT", Announcer_Row, "RIGHT", -10,0)
		Show_Announcer_Toggle:SetSize(26,26)
		Show_Announcer_Toggle:SetScript("OnClick", function(self) MM_Show_Announce_Toggle(MMNS) end)

	local Markings_Frame = CreateFrame("Frame", nil, Features_Settings)
	Markings_Frame:SetPoint("TOPLEFT", Announcer_Row, "BOTTOMLEFT", 0, 0)
	Markings_Frame:SetPoint("TOPRIGHT", Announcer_Row, "BOTTOMRIGHT", 0, 0)
	Markings_Frame:SetHeight(288)
		local Skull_Row = CreateFrame("Frame", nil, Markings_Frame)
		Skull_Row:SetPoint("TOPLEFT", Markings_Frame, "TOPLEFT", 0, 0)
		Skull_Row:SetPoint("TOPRIGHT", Markings_Frame, "TOPRIGHT", 0, 0)
		Skull_Row:SetHeight(Row_Height)
			local Skull_Tex = CreateFrame("Button", "Announce_Skull_Icon", Skull_Row)
			Skull_Tex:SetSize(16,16)
			Skull_Tex:SetPoint("LEFT", Skull_Row, "LEFT",10,0)
			Skull_Tex:SetNormalTexture("interface\\targetingframe\\ui-raidtargetingicons")
			Skull_Tex:GetNormalTexture():SetTexCoord(0.75,1,0.25,0.5)
			Skull_Tex:EnableMouse(false)
			local Announce_Skull_Msg = CreateFrame("EditBox", "Announce_Skull_Msg", Skull_Row, "InputBoxTemplate")
			Announce_Skull_Msg:SetPoint("LEFT", Skull_Tex, "RIGHT", 40,0)
			Announce_Skull_Msg:SetSize(320,20)
			Announce_Skull_Msg:SetScript("OnEnterPressed", function(self) self:ClearFocus(); end);
			Announce_Skull_Msg:SetScript("OnEscapePressed", function(self) self:ClearFocus(); end);
			Announce_Skull_Msg:SetScript("OnEditFocusLost", function(self) self:ClearFocus(); MM_Save_Line("Skull", Announce_Skull_Msg:GetText()); end);
			local Announce_Skull_Toggle = CreateFrame("CheckButton", "Announce_Skull_Toggle", Skull_Row, "UICheckButtonTemplate")
			Announce_Skull_Toggle:SetPoint("RIGHT", Skull_Row, "RIGHT", -10,0)
			Announce_Skull_Toggle:SetSize(26,26)
			Announce_Skull_Toggle:SetScript("OnClick", function(self) Toggle_Announce("Skull") end)

		local Cross_Row = CreateFrame("Frame", nil, Markings_Frame)
		Cross_Row:SetPoint("TOPLEFT", Skull_Row, "BOTTOMLEFT", 0, 0)
		Cross_Row:SetPoint("TOPRIGHT", Skull_Row, "BOTTOMRIGHT", 0, 0)
		Cross_Row:SetHeight(Row_Height)
			local Cross_Tex = CreateFrame("Button", "Cross_Tex", Cross_Row)
			Cross_Tex:SetSize(16,16)
			Cross_Tex:SetPoint("LEFT", Cross_Row, "LEFT",10,0)
			Cross_Tex:SetNormalTexture("interface\\targetingframe\\ui-raidtargetingicons")
			Cross_Tex:GetNormalTexture():SetTexCoord(0.5,0.75,0.25,0.5)
			Cross_Tex:EnableMouse(false)
			local Announce_Cross_Msg = CreateFrame("EditBox", "Announce_Cross_Msg", Cross_Row, "InputBoxTemplate")
			Announce_Cross_Msg:SetPoint("LEFT", Cross_Tex, "RIGHT", 40,0)
			Announce_Cross_Msg:SetSize(320,20)
			Announce_Cross_Msg:SetScript("OnEnterPressed", function(self) self:ClearFocus(); end);
			Announce_Cross_Msg:SetScript("OnEscapePressed", function(self) self:ClearFocus(); end);
			Announce_Cross_Msg:SetScript("OnEditFocusLost", function(self) self:ClearFocus(); MM_Save_Line("Cross", Announce_Cross_Msg:GetText()); end);
			local Announce_Cross_Toggle = CreateFrame("CheckButton", "Announce_Cross_Toggle", Cross_Row, "UICheckButtonTemplate")
			Announce_Cross_Toggle:SetPoint("RIGHT", Cross_Row, "RIGHT", -10,0)
			Announce_Cross_Toggle:SetSize(26,26)
			Announce_Cross_Toggle:SetScript("OnClick", function(self) Toggle_Announce("Cross") end)

		local Square_Row = CreateFrame("Frame", nil, Markings_Frame)
		Square_Row:SetPoint("TOPLEFT", Cross_Row, "BOTTOMLEFT", 0, 0)
		Square_Row:SetPoint("TOPRIGHT", Cross_Row, "BOTTOMRIGHT", 0, 0)
		Square_Row:SetHeight(Row_Height)
			local Square_Tex = CreateFrame("Button", "Square_Tex", Square_Row)
			Square_Tex:SetSize(16,16)
			Square_Tex:SetPoint("LEFT", Square_Row, "LEFT",10,0)
			Square_Tex:SetNormalTexture("interface\\targetingframe\\ui-raidtargetingicons")
			Square_Tex:GetNormalTexture():SetTexCoord(0.25,0.5,0.25,0.5)
			Square_Tex:EnableMouse(false)
			local Announce_Square_Msg = CreateFrame("EditBox", "Announce_Square_Msg", Square_Row, "InputBoxTemplate")
			Announce_Square_Msg:SetPoint("LEFT", Square_Tex, "RIGHT", 40,0)
			Announce_Square_Msg:SetSize(320,20)
			Announce_Square_Msg:SetScript("OnEnterPressed", function(self) self:ClearFocus(); end);
			Announce_Square_Msg:SetScript("OnEscapePressed", function(self) self:ClearFocus(); end);
			Announce_Square_Msg:SetScript("OnEditFocusLost", function(self) self:ClearFocus(); MM_Save_Line("Square", Announce_Square_Msg:GetText()); end);
			local Announce_Square_Toggle = CreateFrame("CheckButton", "Announce_Square_Toggle", Square_Row, "UICheckButtonTemplate")
			Announce_Square_Toggle:SetPoint("RIGHT", Square_Row, "RIGHT",-10,0)
			Announce_Square_Toggle:SetSize(26,26)
			Announce_Square_Toggle:SetScript("OnClick", function(self) Toggle_Announce("Square") end)

		local Moon_Row = CreateFrame("Frame", nil, Markings_Frame)
		Moon_Row:SetPoint("TOPLEFT", Square_Row, "BOTTOMLEFT", 0, 0)
		Moon_Row:SetPoint("TOPRIGHT", Square_Row, "BOTTOMRIGHT", 0, 0)
		Moon_Row:SetHeight(Row_Height)
			local Moon_Tex = CreateFrame("Button", "Moon_Tex", Moon_Row)
			Moon_Tex:SetSize(16,16)
			Moon_Tex:SetPoint("LEFT", Moon_Row, "LEFT",10,0)
			Moon_Tex:SetNormalTexture("interface\\targetingframe\\ui-raidtargetingicons")
			Moon_Tex:GetNormalTexture():SetTexCoord(0,0.25,0.25,0.5)
			Moon_Tex:EnableMouse(false)
			local Announce_Moon_Msg = CreateFrame("EditBox", "Announce_Moon_Msg", Moon_Row, "InputBoxTemplate")
			Announce_Moon_Msg:SetPoint("LEFT", Moon_Tex, "RIGHT", 40,0)
			Announce_Moon_Msg:SetSize(320,20)
			Announce_Moon_Msg:SetScript("OnEnterPressed", function(self) self:ClearFocus(); end);
			Announce_Moon_Msg:SetScript("OnEscapePressed", function(self) self:ClearFocus(); end);
			Announce_Moon_Msg:SetScript("OnEditFocusLost", function(self) self:ClearFocus(); MM_Save_Line("Moon", Announce_Moon_Msg:GetText()); end);
			local Announce_Moon_Toggle = CreateFrame("CheckButton", "Announce_Moon_Toggle", Moon_Row, "UICheckButtonTemplate")
			Announce_Moon_Toggle:SetPoint("RIGHT", Moon_Row, "RIGHT", -10,0)
			Announce_Moon_Toggle:SetSize(26,26)
			Announce_Moon_Toggle:SetScript("OnClick", function(self) Toggle_Announce("Moon") end)
		
		local Triangle_Row = CreateFrame("Frame", nil, Markings_Frame)
		Triangle_Row:SetPoint("TOPLEFT", Moon_Row, "BOTTOMLEFT", 0, 0)
		Triangle_Row:SetPoint("TOPRIGHT", Moon_Row, "BOTTOMRIGHT", 0, 0)
		Triangle_Row:SetHeight(Row_Height)
			local Triangle_Tex = CreateFrame("Button", "Triangle_Tex", Triangle_Row)
			Triangle_Tex:SetSize(16,16)
			Triangle_Tex:SetPoint("LEFT", Triangle_Row, "LEFT",10,0)
			Triangle_Tex:SetNormalTexture("interface\\targetingframe\\ui-raidtargetingicons")
			Triangle_Tex:GetNormalTexture():SetTexCoord(0.75,1,0,0.25)
			Triangle_Tex:EnableMouse(false)
			local Announce_Triangle_Msg = CreateFrame("EditBox", "Announce_Triangle_Msg", Triangle_Row, "InputBoxTemplate")
			Announce_Triangle_Msg:SetPoint("LEFT", Triangle_Tex, "RIGHT", 40,0)
			Announce_Triangle_Msg:SetSize(320,20)
			Announce_Triangle_Msg:SetScript("OnEnterPressed", function(self) self:ClearFocus(); end);
			Announce_Triangle_Msg:SetScript("OnEscapePressed", function(self) self:ClearFocus(); end);
			Announce_Triangle_Msg:SetScript("OnEditFocusLost", function(self) self:ClearFocus(); MM_Save_Line("Triangle", Announce_Triangle_Msg:GetText()); end);
			local Announce_Triangle_Toggle = CreateFrame("CheckButton", "Announce_Triangle_Toggle", Triangle_Row, "UICheckButtonTemplate")
			Announce_Triangle_Toggle:SetPoint("RIGHT", Triangle_Row, "RIGHT",-10,0)
			Announce_Triangle_Toggle:SetSize(26,26)
			Announce_Triangle_Toggle:SetScript("OnClick", function(self) Toggle_Announce("Triangle") end)

		local Diamond_Row = CreateFrame("Frame", nil, Markings_Frame)
		Diamond_Row:SetPoint("TOPLEFT", Triangle_Row, "BOTTOMLEFT", 0, 0)
		Diamond_Row:SetPoint("TOPRIGHT", Triangle_Row, "BOTTOMRIGHT", 0, 0)
		Diamond_Row:SetHeight(Row_Height)
			local Diamond_Tex = CreateFrame("Button", "Diamond_Tex", Diamond_Row)
			Diamond_Tex:SetSize(16,16)
			Diamond_Tex:SetPoint("LEFT", Diamond_Row, "LEFT",10,0)
			Diamond_Tex:SetNormalTexture("interface\\targetingframe\\ui-raidtargetingicons")
			Diamond_Tex:GetNormalTexture():SetTexCoord(0.5,0.75,0,0.25)
			Diamond_Tex:EnableMouse(false)
			local Announce_Diamond_Msg = CreateFrame("EditBox", "Announce_Diamond_Msg", Diamond_Row, "InputBoxTemplate")
			Announce_Diamond_Msg:SetPoint("LEFT", Diamond_Tex, "RIGHT", 40,0)
			Announce_Diamond_Msg:SetSize(320,20)
			Announce_Diamond_Msg:SetScript("OnEnterPressed", function(self) self:ClearFocus(); end);
			Announce_Diamond_Msg:SetScript("OnEscapePressed", function(self) self:ClearFocus(); end);
			Announce_Diamond_Msg:SetScript("OnEditFocusLost", function(self) self:ClearFocus(); MM_Save_Line("Diamond", Announce_Diamond_Msg:GetText()); end);
			local Announce_Diamond_Toggle = CreateFrame("CheckButton", "Announce_Diamond_Toggle", Diamond_Row, "UICheckButtonTemplate")
			Announce_Diamond_Toggle:SetPoint("RIGHT", Diamond_Row, "RIGHT",-10,0)
			Announce_Diamond_Toggle:SetSize(26,26)
			Announce_Diamond_Toggle:SetScript("OnClick", function(self) Toggle_Announce("Diamond") end)

		local Circle_Row = CreateFrame("Frame", nil, Markings_Frame)
		Circle_Row:SetPoint("TOPLEFT", Diamond_Row, "BOTTOMLEFT", 0, 0)
		Circle_Row:SetPoint("TOPRIGHT", Diamond_Row, "BOTTOMRIGHT", 0, 0)
		Circle_Row:SetHeight(Row_Height)
			local Circle_Tex = CreateFrame("Button", "Circle_Tex", Circle_Row)
			Circle_Tex:SetSize(16,16)
			Circle_Tex:SetPoint("LEFT", Circle_Row, "LEFT",10,0)
			Circle_Tex:SetNormalTexture("interface\\targetingframe\\ui-raidtargetingicons")
			Circle_Tex:GetNormalTexture():SetTexCoord(0.25,0.5,0,0.25)
			Circle_Tex:EnableMouse(false)
			local Announce_Circle_Msg = CreateFrame("EditBox", "Announce_Circle_Msg", Circle_Row, "InputBoxTemplate")
			Announce_Circle_Msg:SetPoint("LEFT", Circle_Tex, "RIGHT", 40,0)
			Announce_Circle_Msg:SetSize(320,20)
			Announce_Circle_Msg:SetScript("OnEnterPressed", function(self) self:ClearFocus(); end);
			Announce_Circle_Msg:SetScript("OnEscapePressed", function(self) self:ClearFocus(); end);
			Announce_Circle_Msg:SetScript("OnEditFocusLost", function(self) self:ClearFocus(); MM_Save_Line("Circle", Announce_Circle_Msg:GetText()); end);			
			local Announce_Circle_Toggle = CreateFrame("CheckButton", "Announce_Circle_Toggle", Circle_Row, "UICheckButtonTemplate")
			Announce_Circle_Toggle:SetPoint("RIGHT", Circle_Row, "RIGHT",-10,0)
			Announce_Circle_Toggle:SetSize(26,26)
			Announce_Circle_Toggle:SetScript("OnClick", function(self) Toggle_Announce("Circle") end)			
			
		local Star_Row = CreateFrame("Frame", nil, Markings_Frame)
		Star_Row:SetPoint("TOPLEFT", Circle_Row, "BOTTOMLEFT", 0, 0)
		Star_Row:SetPoint("TOPRIGHT", Circle_Row, "BOTTOMRIGHT", 0, 0)
		Star_Row:SetHeight(Row_Height)
			local Star_Tex = CreateFrame("Button", "Star_Tex", Star_Row)
			Star_Tex:SetSize(16,16)
			Star_Tex:SetPoint("LEFT", Star_Row, "LEFT",10,0)
			Star_Tex:SetNormalTexture("interface\\targetingframe\\ui-raidtargetingicons")
			Star_Tex:GetNormalTexture():SetTexCoord(0,0.25,0,0.25)
			Star_Tex:EnableMouse(false)
			local Announce_Star_Msg = CreateFrame("EditBox", "Announce_Star_Msg", Star_Row, "InputBoxTemplate")
			Announce_Star_Msg:SetPoint("LEFT", Star_Tex, "RIGHT", 40,0)
			Announce_Star_Msg:SetSize(320,20)
			Announce_Star_Msg:SetScript("OnEnterPressed", function(self) self:ClearFocus(); end);
			Announce_Star_Msg:SetScript("OnEscapePressed", function(self) self:ClearFocus(); end);
			Announce_Star_Msg:SetScript("OnEditFocusLost", function(self) self:ClearFocus(); MM_Save_Line("Star", Announce_Star_Msg:GetText()); end);	
			local Announce_Star_Toggle = CreateFrame("CheckButton", "Announce_Star_Toggle", Star_Row, "UICheckButtonTemplate")
			Announce_Star_Toggle:SetPoint("RIGHT", Star_Row, "RIGHT",-10,0)
			Announce_Star_Toggle:SetSize(26,26)
			Announce_Star_Toggle:SetScript("OnClick", function(self) Toggle_Announce("Star") end)

InterfaceOptions_AddCategory(MarkMeOptions.panel);